#
# Copyright 2019 David Carter <dcarter@davesrocketshop.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"), 
# to deal in the Software without restriction, including without limitation 
# the rights to use, copy, modify, merge, publish, distribute, sublicense, 
# and/or sell copies of the Software, and to permit persons to whom the 
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in 
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
# IN THE SOFTWARE.

#Author-David Carter

import adsk.core, adsk.fusion, adsk.cam
                
class NoseShapeHandler():
    def __init__(self, inputs):
        # Common parameters        
        self._solid = inputs.itemById('solid').value
        self._thickness = inputs.itemById('thickness').value

        self._shoulder = inputs.itemById('shoulder').value
        self._shoulderLength = inputs.itemById('shoulderLength').value
        self._shoulderRadius = inputs.itemById('shoulderRadius').value
        
        self._length = inputs.itemById('length').value
        self._radius = inputs.itemById('radius').value
        self._coefficient = inputs.itemById('coefficient').value
        self._resolution = inputs.itemById('resolution').value
        
    def draw(self):
        app = adsk.core.Application.get()

        sketch = adsk.fusion.Sketch.cast(app.activeEditObject)
        if sketch:
            sketch.isComputeDeferred = True

            if self._solid:
                if self._shoulder:
                    self.drawSolidShoulder(sketch)
                else:
                    self.drawSolid(sketch)
            else:
                if self._shoulder:
                    self.drawHollowShoulder(sketch)
                else:
                    self.drawHollow(sketch)

            sketch.isComputeDeferred = False
            return True

        return False
    
    def drawSolid(self, sketch):
        pass
    
    def drawSolidShoulder(self, sketch):
        pass
    
    def drawHollow(self, sketch):
        pass
    
    def drawHollowShoulder(self, sketch):
        pass
